package com.dart.cometchat

import android.util.Log
import com.cometchat.pro.core.CometChat
import com.cometchat.pro.exceptions.CometChatException
import com.cometchat.pro.models.*
import io.flutter.plugin.common.MethodCall
import io.flutter.plugin.common.MethodChannel

public class Messages {

     fun sendMessage(call: MethodCall, result: MethodChannel.Result) {
        val receiverID: String = call.argument("receiverId") ?: ""
        val messageText: String = call.argument("messageText") ?: ""
        val receiverType: String = call.argument("receiverType") ?: ""
        val parentMessageId: Int = call.argument("parentMessageId") ?: -1

        Log.e("receiverType", "$receiverType")


        val textMessage = TextMessage(receiverID, messageText, receiverType)

        if (parentMessageId > 0) textMessage.parentMessageId = parentMessageId

        Log.d("sendMessage", "parentMessageId - $parentMessageId")

        CometChat.sendMessage(textMessage, object : CometChat.CallbackListener<TextMessage>() {
            override fun onSuccess(message: TextMessage) {
                Log.d("sendMessage", "Message sent successfully: $message")
                result.success(GetMap.Companion.getMessageMap(message))
            }

            override fun onError(e: CometChatException) {
                Log.e("sendMessage", "Message sending failed with exception: " + e.message)
                result.error(e.code, e.message, e.details)
            }
        })
    }


}